<id>
Member Awards for YaBB 2.6.11
</id>

<version>
0.2.3
</version>

<mod info>
Description
-----------
This Mod will add a Member Awards system to your forum.

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Upload modified files to your server in ASCII mode.
3) Upload AwardSettings.pm, Awards.lng, Awards.pm and Awards.txt to their relevant directories in ASCII mode.
5) Upload the Awards folder to the ModImages directory in Binary mode.
6) Go into Admin Center => BoardMod Mods => Member Awards to configure the settings.

Files to edit
-------------
AdminIndex.pl
Admin/AdminSubList.pm
Admin/ManageTemplates.pm
Admin/ModList.pm
Languages/English/Admin.lng
Languages/English/Error.lng
Languages/English/Menu.lng
Sources/AdvancedTabs.pm
Sources/Display.pm
Sources/Load.pm
Sources/MyCenter.pm
Sources/Profile.pm
Sources/SubList.pm
Sources/Subs.pm
Sources/TabMenu.pm
Templates/default/Display.template
Templates/default/MyCenter.template
Templates/default/MyProfile.template
Templates/default/Menu.def
Variables/Settings.pm

Version History
---------------
0.1 - First Release - 18th March 2011
0.2 - Added option to send automatic PM after Awarding Members - 21st March 2011
0.2.1 - Added PM tags - 21st March 2011
0.2.2 - Updated for 2.6 - 14th Oct 2015  by Dandello
0.2.3 - fixed typo in template
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://boardmod.org
</homepage>

<edit file>
AdminIndex.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    $awards_mod = "awards|$mod_list{'awards'}|$mod_list{'awards1'}|";
    push (@boardmod_mods, "$awards_mod");

</add before>

<edit file>
Admin/AdminSubList.pm
</edit file>

<search for>
1;
</search for>

<add before>
# Member Awards Mod Start
$director{'awards'} = 'Mods/AwardSettings.pm&Awards';
$director{'awards2'} = 'Mods/AwardSettings.pm&Awards2';
$director{'awards_add'} = 'Mods/AwardSettings.pm&AddAward';
$director{'awards_delete'} = 'Mods/AwardSettings.pm&DeleteAward';
$director{'awards_edit'} = 'Mods/AwardSettings.pm&EditAward';
$director{'awards_edit2'} = 'Mods/AwardSettings.pm&EditAward2',
# Member Awards Mod End

</add before>

<edit file>
Admin/ManageTemplates.pm
</edit file>

<search for>
        $outblock =~ s/({|<)yabb gender(}|>)//gsm;
</search for>

<add after>
        $outblock =~ s/({|<)yabb awards(}|>)//gsm; # Member Awards Mod
</add after>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    $awards_mod = qq~Member Awards|Derek Barnstorm|This Mod will add a Member Awards system to your forum. [<span class="small"><a href="$adminurl?action=awards" style="font-weight: bold;">Member Award Settings</a></span>]|0.2.2|14th Oct 2015~;
    push (@installed_mods, "$awards_mod");
</add before>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
1;
</search for>

<add before>
$mod_list{'awards'} = 'Member Awards'; # Member Awards Mod
$mod_list{'awards1'} = 'Member Award Settings'; # Member Awards Mod

</add before>

<edit file>
Languages/English/Error.lng
</edit file>

<search for>
1;
</search for>

<add before>
$error_txt{'no_award'} = q~You must select an Award.~; # Member Awards Mod
$error_txt{'no_award_reason'} = q~You must enter an Award Reason.~; # Member Awards Mod
$error_txt{'no_value'} = q~You must enter a value for:~; # Member Awards Mod

</add before>

<edit file>
Languages/English/Menu.lng
</edit file>

<search for>
1;
</search for>

<add before>
$img_txt{'awards'} = 'Awards'; # Member Awards Mod
</add before>

<edit file>
Sources/AdvancedTabs.pm
</edit file>

<search for>
## End Mod hook tablist ##
</search for>

<add before>
    push @tablist, 'awards'; # Member Awards Mod
</add before>

<search for>
## End Mod Hook GetTextTab ##
</search for>

<add before>
    $texttab{'awards'}            = $img_txt{'awards'}; # Member Awards Mod
</add before>

<edit file>
Sources/Display.pm
</edit file>

<search for>
sub Display {
</search for>

<add before>
# Member Awards Mod Start
if (-e("$vardir/AwardSettings.txt")) { require "$vardir/AwardSettings.txt"; }
if ($en_awards && $en_awards_mv) {
    require "$sourcedir/Mods/Awards.pm";
    LoadAwards();
}
# Member Awards Mod End

</add before>

<search for>
## Mod Hook Outbox ##
</search for>

<add before>
        $outblock =~ s/{yabb awards}/$member_awards{$musername}/gsm; # Member Awards Mod
</add before>

<edit file>
Sources/Load.pm
</edit file>

<search for>
    LoadMiniUser($user);
</search for>

<add before>

    # Member Awards Mod start
    if (-e "$vardir/AwardSettings.txt") { require "$vardir/AwardSettings.txt"; }
    if ($en_awards && $en_awards_mv) {
        if (-e "$memberdir/$user.awards") {
            fopen (UAWARDS, "<$memberdir/$user.awards");
            @getawards = <UAWARDS>;
            fclose(UAWARDS);
            if (@getawards && $total_awards) {
                my $awards = q{};
                $count_awards = 0;
                foreach my $user_award (sort { $b <=> $a } @getawards) {
                    chomp $user_award;
                    (undef, $user_award_id, undef, undef) = split /\|/xsm, $user_award;
                    foreach my $award (@awards) {
                        if ($award =~ /\b$user_award_id\b/) {
                           (undef, $award_id, $award_title, $award_image, undef) = split /\|/xsm, $award;
                        }
                    }
                    if ($user_award_id eq $award_id) {
                        $awards .= qq~<a href="$scripturl?action=awards;id=$award_id"><img src="$modimgurl/Awards/$award_image" alt="$award_title" title="$award_title" /></a>~;
                        $count_awards ++;
                    }
                }
                if ($awards) { $member_awards{$user} = qq~$awards_name: <a href="$scripturl?action=awards;username=$useraccount{$user}">$count_awards</a><br />$awards<br />~;}
            }
            else {
                $member_awards{$user} = q{};
            }
        }
    }
    # Member Awards Mod end
</add before>

<edit file>
Sources/MyCenter.pm
</edit file>

<search for>
$mycenter_txt{'welcometxt'} =~ s/USERLABEL/${$uid.$username}{'realname'}/gxsm;
</search for>

<add after>

# Member Awards Mod Start
if (-e("$vardir/AwardSettings.txt")) { require "$vardir/AwardSettings.txt"; }
if ($en_awards && $en_awards_mv) {
    require "$sourcedir/Mods/Awards.pm";
    LoadAwards();
}
# Member Awards Mod End
</add after>

<search for>
## Mod Hook myprofileblock ##
</search for>

<add before>
        $myprofileblock =~ s/{yabb awards}/$member_awards{$username}/gsm; # Member Awards Mod
</add before>

<edit file>
Sources/Profile.pm
</edit file>

<search for>
        unlink "$memberdir/$noteuser.imdraft";
</search for>

<add after>
        unlink "$memberdir/$noteuser.awards"; # Member Awards Mod
</add after>

<search for>
        $row_website,  $row_signature, $showusertext
    );
</search for>

<add after>
    my ($row_awards);    # Member Awards Mod
</add after>

<search for>
    # End empty field checking
</search for>

<add before>

    # Member Awards Mod start
    if ( -e "$vardir/AwardSettings.txt" ) {
        require "$vardir/AwardSettings.txt";
    }
    if ($en_awards) {
        get_template('Mods/Awards');
        LoadLanguage('Mods/Awards');
        $count_awards = 0;
        my $row_award = q{};
        $edit_span = '5';
        if ( $iamadmin || $iamgmod && $en_awards_gmod ) {
            $awards_admin_header = $tem_awards_admin_header;
            $row_add_award       = $tem_row_add_award;
            $row_add_award =~ s/{award id}/$useraccount{$user}/gsm;
            $row_add_award =~ s/{award_txt}/$award_txt{'16'}/gsm;
        }
        if ( -e "$memberdir/$user.awards" ) {
            fopen( UAWARDS, "<$memberdir/$user.awards" );
            @getawards = <UAWARDS>;
            fclose(UAWARDS);
            if (@getawards) {
                require "$sourcedir/Mods/Awards.pm";
                LoadAwards();
                $row_award = $tem_row_award_1;
                $row_award =~ s/{awards_admin_header}/$awards_admin_header/gsm;

                foreach my $user_award ( sort { $b <=> $a } @getawards ) {
                    chomp $user_award;
                    (
                        $user_award_date,   $user_award_id,
                        $user_award_reason, $user_award_who
                    ) = split /\|/xsm, $user_award;
                    $id = $user_award_date;
                    LoadUser($user_award_who);
                    $who_name        = $link{$user_award_who};
                    $user_award_date = timeformat($user_award_date);
                    foreach my $award (@awards) {
                        if ( $award =~ /\b$user_award_id\b/ ) {
                            (
                                undef, $award_id, $award_title, $award_image,
                                undef
                            ) = split /\|/xsm, $award;
                        }
                    }
                    $awards_admin = q{};
                    if ( $iamadmin || $iamgmod && $en_awards_gmod ) {
                        $edit_span    = '6';
                        $awards_admin = $tem_awards_admin;
                        $awards_admin =~ s/{user_award_date}/$id/gsm;
                        $awards_admin =~
                          s/{yabb username}/$useraccount{$user}/gsm;
                    }
                    if ( $user_award_id eq $award_id ) {
                        $row_award .= $tem_row_award_2;
                        $row_award =~ s/{user_award_id}/$user_award_id/gsm;
                        $row_award =~ s/{award_title}/$award_title/gsm;
                        $row_award =~
                          s/{user_award_reason}/$user_award_reason/gsm;
                        $row_award =~ s/{user_award_date}/$user_award_date/gsm;
                        $row_award =~ s/{who_name}/$who_name/gsm;
                        $row_award =~ s/{awards_admin}/$awards_admin/gsm;
                        $row_award =~
s/{yabb awardimg}/$modimgurl\/Awards\/$award_image/gsm;
                        $count_awards++;
                    }
                    elsif ( $iamadmin || $iamgmod && $en_awards_gmod ) {
                        $row_award .= $tem_row_award_3;
                        $row_award =~ s/{user_award_id}/$user_award_id/gsm;
                        $row_award =~ s/{user_award_date}/$id/gsm;
                        $row_award =~ s/{yabb username}/$useraccount{$user}/gsm;
                    }
                }
            }
        }
        if ( @getawards || ( $iamadmin || $iamgmod && $en_awards_gmod ) ) {
            $row_awards = $tem_row_awards;
            $row_awards =~ s/{yabb awards_name}/$awards_name/gsm;
            $row_awards =~ s/{yabb count_awards}/$count_awards/gsm;
            $row_awards =~ s/{yabb row_award}/$row_award/gsm;
            $row_awards =~ s/{yabb row_add_award}/$row_add_award/gsm;
        }
    }

    # Member Awards Mod End
</add before>

<search for>
## Mod Hook showProfile2 ##
</search for>

<add before>

    $showProfile =~ s/{yabb row_awards}/$row_awards/sm;
</add before>

<edit file>
Sources/SubList.pm
</edit file>

<search for>
1;
</search for>

<add before>
# Member Awards Mod Start
$director{'awards'} = 'Mods/Awards.pm&Awards';
$director{'awards_delete'} = 'Mods/Awards.pm&AwardDelete';
$director{'awards_edit'} = 'Mods/Awards.pm&AwardEdit';
$director{'awards_edit2'} = 'Mods/Awards.pm&AwardEdit2';
$director{'awards_member'} = 'Mods/Awards.pm&AwardMember';
$director{'awards_member2'} = 'Mods/Awards.pm&AwardMember2';
# Member Awards Mod End

</add before>

<edit file>
Sources/TabMenu.pm
</edit file>

<search for>
## Tab Mod Hook ##
</search for>

<add before>
    # Member Awards Mod Start
    if (-e "$vardir/AwardSettings.txt") { require "$vardir/AwardSettings.txt"; }
    if ($en_awards_tab) {
         $tab{'awards'} = qq~$tabhtml_l"$scripturl?action=awards" title="$img_txt{'awards'}">$img_txt{'awards'}</a>$tabhtml_r~;
    }
    # Member Awards Mod End
</add before>

<edit file>
Templates/default/Display.template
</edit file>

<search for>
                        {yabb gender}
</search for>

<add after>
                        {yabb awards}
</add after>

<edit file>
Templates/default/MyCenter.template
</edit file>

<search for>
        {yabb gender}
</search for>

<add after>
        {yabb awards}
</add after>

<edit file>
Templates/default/MyProfile.template
</edit file>

<search for>
{yabb row_signature}
</search for>

<add before>
{yabb row_awards}
</add before>

<edit file>
Templates/default/Menu.def
</edit file>

<search for>
youtube,youtube|img_txt|youtube|||imgwindowbg|gif|tmp
</search for>

<add after>
awards,awards|$img_txt|awards|||imgwindowbg|gif|mod
</add after>

<edit file>
Variables/Settings.pm
</edit file>

<search for>
1;
</search for>

<add before>
push @AdvancedTabs, 'awards';

</add before>
